/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.5.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/CreatePaymentSetupRequest', 'models/DeletePaymentSetupRequest', 'models/DeleteResponse', 'models/ErrorResponseVo', 'models/PaymentSetupResponse', 'models/PaymentSetupsResponse', 'models/UpdatePaymentSetupRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../models/CreatePaymentSetupRequest'), require('../models/DeletePaymentSetupRequest'), require('../models/DeleteResponse'), require('../models/ErrorResponseVo'), require('../models/PaymentSetupResponse'), require('../models/PaymentSetupsResponse'), require('../models/UpdatePaymentSetupRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.PaymentSetupApi = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.CreatePaymentSetupRequest, root.OrbipayPaymentsapiClient.DeletePaymentSetupRequest, root.OrbipayPaymentsapiClient.DeleteResponse, root.OrbipayPaymentsapiClient.ErrorResponseVo, root.OrbipayPaymentsapiClient.PaymentSetupResponse, root.OrbipayPaymentsapiClient.PaymentSetupsResponse, root.OrbipayPaymentsapiClient.UpdatePaymentSetupRequest);
  }
}(this, function(ApiClient, CreatePaymentSetupRequest, DeletePaymentSetupRequest, DeleteResponse, ErrorResponseVo, PaymentSetupResponse, PaymentSetupsResponse, UpdatePaymentSetupRequest) {
  'use strict';

  /**
   * PaymentSetup service.
   * @module api/PaymentSetupApi
   * @version 1.5.0
   */

  /**
   * Constructs a new PaymentSetupApi. 
   * @alias module:api/PaymentSetupApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the createPaymentSetup operation.
     * @callback module:api/PaymentSetupApi~createPaymentSetupCallback
     * @param {String} error Error message, if any.
     * @param {module:models/PaymentSetupResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create Payment Setup
     * The API is used to set up recurring payments to service a customer account.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by OrbiPay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by OrbiPay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {String} requestor The identifier for the requestor of the API, in OrbiPay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the OrbiPay generated customer id, for user, it would be the OrbiPay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
     * @param {module:models/String} requestor_type Type of the requestor of the API.
     * @param {String} id_customer The unique identifier assigned by OrbiPay to the customer.
     * @param {module:models/CreatePaymentSetupRequest} create_payment_setup_request JSON containing all the fields required to create a recurring payment setup.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/PaymentSetupApi~createPaymentSetupCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/PaymentSetupResponse}
     */
    this.createPaymentSetup = function(channel, client_key, product, timestamp, idempotent_request_key, requestor, requestor_type, id_customer, create_payment_setup_request, opts, callback) {
      opts = opts || {};
      var postBody = create_payment_setup_request;

      var pathParams = {
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor': requestor,
        'requestor_type': requestor_type,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PaymentSetupResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/paymentsetups', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the deletePaymentSetup operation.
     * @callback module:api/PaymentSetupApi~deletePaymentSetupCallback
     * @param {String} error Error message, if any.
     * @param {module:models/DeleteResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Payment Setup
     * The API is used to delete or cancel a recurring payment setup. Cancelling a payment setup will also cancel all the pending and future payments under the setup.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by OrbiPay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by OrbiPay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {String} requestor The identifier for the requestor of the API, in OrbiPay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the OrbiPay generated customer id, for user, it would be the OrbiPay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
     * @param {module:models/String} requestor_type Type of the requestor of the API.
     * @param {String} id_payment_setup The unique identifier assigned by OrbiPay to the payment setup.
     * @param {String} id_customer The unique identifier assigned by OrbiPay to the customer.
     * @param {module:models/DeletePaymentSetupRequest} delete_payment_setup_request JSON containing all the fields required to delete a payment. Setup.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/PaymentSetupApi~deletePaymentSetupCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/DeleteResponse}
     */
    this.deletePaymentSetup = function(channel, client_key, product, timestamp, idempotent_request_key, requestor, requestor_type, id_payment_setup, id_customer, delete_payment_setup_request, opts, callback) {
      opts = opts || {};
      var postBody = delete_payment_setup_request;

      var pathParams = {
        'ID_PAYMENT_SETUP': id_payment_setup,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor': requestor,
        'requestor_type': requestor_type,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = DeleteResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the getPaymentSetup operation.
     * @callback module:api/PaymentSetupApi~getPaymentSetupCallback
     * @param {String} error Error message, if any.
     * @param {module:models/PaymentSetupResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Payment Setup
     * The API is used to retrieve the details of a recurring payment setup by id.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by OrbiPay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by OrbiPay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {String} requestor The identifier for the requestor of the API, in OrbiPay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the OrbiPay generated customer id, for user, it would be the OrbiPay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
     * @param {module:models/String} requestor_type Type of the requestor of the API.
     * @param {String} id_payment_setup The unique identifier assigned by OrbiPay to the payment setup.
     * @param {String} id_customer The unique identifier assigned by OrbiPay to the customer.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/PaymentSetupApi~getPaymentSetupCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/PaymentSetupResponse}
     */
    this.getPaymentSetup = function(channel, client_key, product, timestamp, idempotent_request_key, requestor, requestor_type, id_payment_setup, id_customer, opts, callback) {
      opts = opts || {};
      var postBody = null;

      var pathParams = {
        'ID_PAYMENT_SETUP': id_payment_setup,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor': requestor,
        'requestor_type': requestor_type,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PaymentSetupResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the retrievePaymentSetups operation.
     * @callback module:api/PaymentSetupApi~retrievePaymentSetupsCallback
     * @param {String} error Error message, if any.
     * @param {module:models/PaymentSetupsResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieve Payment Setups
     * The API is used to retrieve the recurring and autopay payments setup made against a customer account. The setup can be filtered using the confirmation number, customer account, funding account, status and payment setup schedule type, by date range and others mentioned below. If no dates are provided for retrieval, recurring payments set up in the last six months and all the ones in future are returned. If the requestor type is customer then the id_customer request parameter is mandatory.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by OrbiPay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by OrbiPay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {String} requestor The identifier for the requestor of the API, in OrbiPay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the OrbiPay generated customer id, for user, it would be the OrbiPay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
     * @param {module:models/String} requestor_type Type of the requestor of the API.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {String} opts.id_customer The unique identifier assigned by OrbiPay to the customer.
     * @param {String} opts.id_funding_account The unique identifier assigned by OrbiPay to the funding account
     * @param {String} opts.id_customer_account The unique identifier assigned by OrbiPay to the customer account
     * @param {String} opts.confirmation_number The confirmation number or reference provided to the customer for the successful payment.
     * @param {Array.<module:models/String>} opts.status The status of the payment. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
     * @param {Array.<module:models/String>} opts.payment_setup_schedule_type The schedule type for the payment setup. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2....
     * @param {String} opts.from_date The date from which recurring payments setup, matching the criteria specified, need to be retrieved.
     * @param {String} opts.to_date The date upto which recurring payments setup, matching the criteria specified, need to be retrieved.
     * @param {String} opts.page_size The maximum number of objects returned in the query.
     * @param {String} opts.query_id query id of the Retrieve/Search Customers lookup.
     * @param {String} opts.from_index To fetch the next set of objects that start after this object
     * @param {String} opts.to_index To fetch the previous set of objects that end at this object
     * @param {module:api/PaymentSetupApi~retrievePaymentSetupsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/PaymentSetupsResponse}
     */
    this.retrievePaymentSetups = function(channel, client_key, product, timestamp, idempotent_request_key, requestor, requestor_type, opts, callback) {
      opts = opts || {};
      var postBody = null;

      var pathParams = {
      };
      var queryParams = {
        'id_customer': opts['id_customer'],
        'id_funding_account': opts['id_funding_account'],
        'id_customer_account': opts['id_customer_account'],
        'confirmation_number': opts['confirmation_number'],
        'status': opts['status'],
        'payment_setup_schedule_type': opts['payment_setup_schedule_type'],
        'from_date': opts['from_date'],
        'to_date': opts['to_date'],
        'page_size': opts['page_size'],
        'query_id': opts['query_id'],
        'from_index': opts['from_index'],
        'to_index': opts['to_index']
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor': requestor,
        'requestor_type': requestor_type,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PaymentSetupsResponse;

      return this.apiClient.callApi(
        '/paymentsetups', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };

    /**
     * Callback function to receive the result of the updatePaymentSetup operation.
     * @callback module:api/PaymentSetupApi~updatePaymentSetupCallback
     * @param {String} error Error message, if any.
     * @param {module:models/PaymentSetupResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Payment Setup
     * The API is used to edit a payment Setup. Only autopay payment setup is edited.
     * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
     * @param {String} client_key The unique identifier assigned by OrbiPay to the client.
     * @param {module:models/String} product The product identifier corresponding to the API.
     * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
     * @param {String} idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by OrbiPay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details.
     * @param {String} requestor The identifier for the requestor of the API, in OrbiPay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the OrbiPay generated customer id, for user, it would be the OrbiPay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
     * @param {module:models/String} requestor_type Type of the requestor of the API.
     * @param {String} id_payment_setup The unique identifier assigned by OrbiPay to the payment setup.
     * @param {String} id_customer The unique identifier assigned by OrbiPay to the customer.
     * @param {module:models/UpdatePaymentSetupRequest} update_payment_setup_request Details of the Payment Setup to be updated.
     * @param {Object} opts Optional parameters
     * @param {String} opts.x_opay_headers Intended for the future use.
     * @param {module:api/PaymentSetupApi~updatePaymentSetupCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:models/PaymentSetupResponse}
     */
    this.updatePaymentSetup = function(channel, client_key, product, timestamp, idempotent_request_key, requestor, requestor_type, id_payment_setup, id_customer, update_payment_setup_request, opts, callback) {
      opts = opts || {};
      var postBody = update_payment_setup_request;

      var pathParams = {
        'ID_PAYMENT_SETUP': id_payment_setup,
        'ID_CUSTOMER': id_customer
      };
      var queryParams = {
      };
      var headerParams = {
        'channel': channel,
        'client_key': client_key,
        'product': product,
        'timestamp': timestamp,
        'idempotent_request_key': idempotent_request_key,
        'requestor': requestor,
        'requestor_type': requestor_type,
        'X-OPAY-Headers': opts['x_opay_headers']
      };
      var formParams = {
      };

      var authNames = ['ApiKeyAuth'];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = PaymentSetupResponse;

      return this.apiClient.callApi(
        '/customers/{ID_CUSTOMER}/paymentsetups/{ID_PAYMENT_SETUP}', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    };
  };

  return exports;
}));
