/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.5.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/PaymentSetupResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PaymentSetupResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.PaymentSetupsResponse = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.PaymentSetupResponse);
  }
}(this, function(ApiClient, PaymentSetupResponse) {
  'use strict';




  /**
   * The PaymentSetupsResponse model module.
   * @module models/PaymentSetupsResponse
   * @version 1.5.0
   */

  /**
   * Constructs a new <code>PaymentSetupsResponse</code>.
   * @alias module:models/PaymentSetupsResponse
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>PaymentSetupsResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/PaymentSetupsResponse} obj Optional instance to populate.
   * @return {module:models/PaymentSetupsResponse} The populated <code>PaymentSetupsResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('list')) {
        obj['list'] = ApiClient.convertToType(data['list'], [PaymentSetupResponse]);
      }
      if (data.hasOwnProperty('total_results_count')) {
        obj['total_results_count'] = ApiClient.convertToType(data['total_results_count'], 'String');
      }
      if (data.hasOwnProperty('has_more_results')) {
        obj['has_more_results'] = ApiClient.convertToType(data['has_more_results'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('query_id')) {
        obj['query_id'] = ApiClient.convertToType(data['query_id'], 'String');
      }
      if (data.hasOwnProperty('from_index')) {
        obj['from_index'] = ApiClient.convertToType(data['from_index'], 'String');
      }
      if (data.hasOwnProperty('to_index')) {
        obj['to_index'] = ApiClient.convertToType(data['to_index'], 'String');
      }
    }
    return obj;
  };

  /**
   * @member {Array.<module:models/PaymentSetupResponse>} list
   */
  exports.prototype['list'] = undefined;
  /**
   * The total number of payment setup available matching the search criteria.
   * @member {String} total_results_count
   */
  exports.prototype['total_results_count'] = undefined;
  /**
   * true if there are more results or pages
   * @member {module:models/PaymentSetupsResponse.HasMoreResultsEnum} has_more_results
   */
  exports.prototype['has_more_results'] = undefined;
  /**
   * This URL fetches the next or previous set of payment setups, based on the presence of after_object or before_object parameter.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * This Query Id is used in next pagination calls.
   * @member {String} query_id
   */
  exports.prototype['query_id'] = undefined;
  /**
   * The id of the object before which the previous set of objects are to be retrieved.
   * @member {String} from_index
   */
  exports.prototype['from_index'] = undefined;
  /**
   * The id of the object after which the next set of objects are to be retrieved.
   * @member {String} to_index
   */
  exports.prototype['to_index'] = undefined;


  /**
   * Allowed values for the <code>has_more_results</code> property.
   * @enum {String}
   * @readonly
   */
  exports.HasMoreResultsEnum = {
    /**
     * value: "true"
     * @const
     */
    "true": "true",
    /**
     * value: "false"
     * @const
     */
    "false": "false"  };


  return exports;
}));


