/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.5.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/PaymentResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PaymentResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.RefundObject = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.PaymentResponse);
  }
}(this, function(ApiClient, PaymentResponse) {
  'use strict';




  /**
   * The RefundObject model module.
   * @module models/RefundObject
   * @version 1.5.0
   */

  /**
   * Constructs a new <code>RefundObject</code>.
   * @alias module:models/RefundObject
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>RefundObject</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/RefundObject} obj Optional instance to populate.
   * @return {module:models/RefundObject} The populated <code>RefundObject</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('payment')) {
        obj['payment'] = PaymentResponse.constructFromObject(data['payment']);
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('expected_refund_settlement_date')) {
        obj['expected_refund_settlement_date'] = ApiClient.convertToType(data['expected_refund_settlement_date'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('confirmation_number')) {
        obj['confirmation_number'] = ApiClient.convertToType(data['confirmation_number'], 'String');
      }
      if (data.hasOwnProperty('refund_reference')) {
        obj['refund_reference'] = ApiClient.convertToType(data['refund_reference'], 'String');
      }
      if (data.hasOwnProperty('refund_type')) {
        obj['refund_type'] = ApiClient.convertToType(data['refund_type'], 'String');
      }
      if (data.hasOwnProperty('refund_amount')) {
        obj['refund_amount'] = ApiClient.convertToType(data['refund_amount'], 'String');
      }
      if (data.hasOwnProperty('comments')) {
        obj['comments'] = ApiClient.convertToType(data['comments'], 'String');
      }
      if (data.hasOwnProperty('custom_fields')) {
        obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], {'String': 'String'});
      }
    }
    return obj;
  };

  /**
   * @member {module:models/PaymentResponse} payment
   */
  exports.prototype['payment'] = undefined;
  /**
   * The unique identifier assigned by OrbiPay to the refund.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * This URL fetches the details of refund.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * The date by which the credits would be posted to the original funding account. ISO8601 full-date format, YYYY-MM-DD
   * @member {String} expected_refund_settlement_date
   */
  exports.prototype['expected_refund_settlement_date'] = undefined;
  /**
   * The status of the refund.
   * @member {module:models/RefundObject.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * The confirmation number or reference provided to the customer for the refund.
   * @member {String} confirmation_number
   */
  exports.prototype['confirmation_number'] = undefined;
  /**
   * The unique identifier in the client system for the refund.
   * @member {String} refund_reference
   */
  exports.prototype['refund_reference'] = undefined;
  /**
   * The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.
   * @member {module:models/RefundObject.RefundTypeEnum} refund_type
   */
  exports.prototype['refund_type'] = undefined;
  /**
   * The refund amount upto 2 decimal places.
   * @member {String} refund_amount
   */
  exports.prototype['refund_amount'] = undefined;
  /**
   * @member {String} comments
   */
  exports.prototype['comments'] = undefined;
  /**
   * The additional information or meta-information that OrbiPay can accept, maintain and transmit back to the client. The custom fields need to be configured with OrbiPay before they can be accepted. OrbiPay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
   * @member {Object.<String, String>} custom_fields
   */
  exports.prototype['custom_fields'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "scheduled"
     * @const
     */
    "scheduled": "scheduled",
    /**
     * value: "processing"
     * @const
     */
    "processing": "processing",
    /**
     * value: "processed"
     * @const
     */
    "processed": "processed",
    /**
     * value: "declined"
     * @const
     */
    "declined": "declined"  };

  /**
   * Allowed values for the <code>refund_type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.RefundTypeEnum = {
    /**
     * value: "payment_and_fee"
     * @const
     */
    "payment_and_fee": "payment_and_fee",
    /**
     * value: "payment_only"
     * @const
     */
    "payment_only": "payment_only",
    /**
     * value: "fee_only"
     * @const
     */
    "fee_only": "fee_only",
    /**
     * value: "other"
     * @const
     */
    "other": "other"  };


  return exports;
}));


