/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.5.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'models/AuditInfoVo', 'models/CustomerAccountResponse', 'models/FeeResponse', 'models/FundingAccountResponse', 'models/PaymentNetworkResponseVo', 'models/SimplePaymentCustomerResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AuditInfoVo'), require('./CustomerAccountResponse'), require('./FeeResponse'), require('./FundingAccountResponse'), require('./PaymentNetworkResponseVo'), require('./SimplePaymentCustomerResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.SimplePaymentResponse = factory(root.OrbipayPaymentsapiClient.ApiClient, root.OrbipayPaymentsapiClient.AuditInfoVo, root.OrbipayPaymentsapiClient.CustomerAccountResponse, root.OrbipayPaymentsapiClient.FeeResponse, root.OrbipayPaymentsapiClient.FundingAccountResponse, root.OrbipayPaymentsapiClient.PaymentNetworkResponseVo, root.OrbipayPaymentsapiClient.SimplePaymentCustomerResponse);
  }
}(this, function(ApiClient, AuditInfoVo, CustomerAccountResponse, FeeResponse, FundingAccountResponse, PaymentNetworkResponseVo, SimplePaymentCustomerResponse) {
  'use strict';




  /**
   * The SimplePaymentResponse model module.
   * @module models/SimplePaymentResponse
   * @version 1.5.0
   */

  /**
   * Constructs a new <code>SimplePaymentResponse</code>.
   * @alias module:models/SimplePaymentResponse
   * @class
   */
  var exports = function() {
    var _this = this;


























  };

  /**
   * Constructs a <code>SimplePaymentResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/SimplePaymentResponse} obj Optional instance to populate.
   * @return {module:models/SimplePaymentResponse} The populated <code>SimplePaymentResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('fee')) {
        obj['fee'] = FeeResponse.constructFromObject(data['fee']);
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('payment_method')) {
        obj['payment_method'] = ApiClient.convertToType(data['payment_method'], 'String');
      }
      if (data.hasOwnProperty('confirmation_number')) {
        obj['confirmation_number'] = ApiClient.convertToType(data['confirmation_number'], 'String');
      }
      if (data.hasOwnProperty('custom_fields')) {
        obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], {'String': 'String'});
      }
      if (data.hasOwnProperty('currency_code3d')) {
        obj['currency_code3d'] = ApiClient.convertToType(data['currency_code3d'], 'String');
      }
      if (data.hasOwnProperty('amount')) {
        obj['amount'] = ApiClient.convertToType(data['amount'], 'String');
      }
      if (data.hasOwnProperty('card_cvv_number')) {
        obj['card_cvv_number'] = ApiClient.convertToType(data['card_cvv_number'], 'String');
      }
      if (data.hasOwnProperty('payment_date')) {
        obj['payment_date'] = ApiClient.convertToType(data['payment_date'], 'String');
      }
      if (data.hasOwnProperty('payment_schedule_type')) {
        obj['payment_schedule_type'] = ApiClient.convertToType(data['payment_schedule_type'], 'String');
      }
      if (data.hasOwnProperty('payment_request_date')) {
        obj['payment_request_date'] = ApiClient.convertToType(data['payment_request_date'], 'String');
      }
      if (data.hasOwnProperty('payment_amount_type')) {
        obj['payment_amount_type'] = ApiClient.convertToType(data['payment_amount_type'], 'String');
      }
      if (data.hasOwnProperty('payment_reference')) {
        obj['payment_reference'] = ApiClient.convertToType(data['payment_reference'], 'String');
      }
      if (data.hasOwnProperty('expected_payment_settlement_date')) {
        obj['expected_payment_settlement_date'] = ApiClient.convertToType(data['expected_payment_settlement_date'], 'String');
      }
      if (data.hasOwnProperty('payment_entry_date')) {
        obj['payment_entry_date'] = ApiClient.convertToType(data['payment_entry_date'], 'String');
      }
      if (data.hasOwnProperty('payment_return_date')) {
        obj['payment_return_date'] = ApiClient.convertToType(data['payment_return_date'], 'String');
      }
      if (data.hasOwnProperty('return_code')) {
        obj['return_code'] = ApiClient.convertToType(data['return_code'], 'String');
      }
      if (data.hasOwnProperty('comments')) {
        obj['comments'] = ApiClient.convertToType(data['comments'], 'String');
      }
      if (data.hasOwnProperty('customer')) {
        obj['customer'] = SimplePaymentCustomerResponse.constructFromObject(data['customer']);
      }
      if (data.hasOwnProperty('funding_account')) {
        obj['funding_account'] = FundingAccountResponse.constructFromObject(data['funding_account']);
      }
      if (data.hasOwnProperty('customer_account')) {
        obj['customer_account'] = CustomerAccountResponse.constructFromObject(data['customer_account']);
      }
      if (data.hasOwnProperty('payment_network_response')) {
        obj['payment_network_response'] = PaymentNetworkResponseVo.constructFromObject(data['payment_network_response']);
      }
      if (data.hasOwnProperty('audit_info')) {
        obj['audit_info'] = AuditInfoVo.constructFromObject(data['audit_info']);
      }
    }
    return obj;
  };

  /**
   * The unique identifier assigned by Orbipay to the payment.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * This URL fetches the details of payment.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * @member {module:models/FeeResponse} fee
   */
  exports.prototype['fee'] = undefined;
  /**
   * The status of the payment.
   * @member {module:models/SimplePaymentResponse.StatusEnum} status
   */
  exports.prototype['status'] = undefined;
  /**
   * The fulfillment method for the payment.
   * @member {module:models/SimplePaymentResponse.PaymentMethodEnum} payment_method
   */
  exports.prototype['payment_method'] = undefined;
  /**
   * The confirmation number or reference provided to the customer for the payment.
   * @member {String} confirmation_number
   */
  exports.prototype['confirmation_number'] = undefined;
  /**
   * The additional information or meta-information that OrbiPay can accept, maintain and transmit back to the client. The custom fields need to be configured with OrbiPay before they can be accepted. OrbiPay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
   * @member {Object.<String, String>} custom_fields
   */
  exports.prototype['custom_fields'] = undefined;
  /**
   * The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
   * @member {String} currency_code3d
   */
  exports.prototype['currency_code3d'] = undefined;
  /**
   * The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
   * @member {String} amount
   */
  exports.prototype['amount'] = undefined;
  /**
   * This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
   * @member {String} card_cvv_number
   */
  exports.prototype['card_cvv_number'] = undefined;
  /**
   * The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
   * @member {String} payment_date
   */
  exports.prototype['payment_date'] = undefined;
  /**
   * The schedule type for the payment. This defaults to one_time_payment.
   * @member {module:models/SimplePaymentResponse.PaymentScheduleTypeEnum} payment_schedule_type
   */
  exports.prototype['payment_schedule_type'] = undefined;
  /**
   * The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD. This is applicable only if the client has opted for it.
   * @member {String} payment_request_date
   */
  exports.prototype['payment_request_date'] = undefined;
  /**
   * The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.
   * @member {module:models/SimplePaymentResponse.PaymentAmountTypeEnum} payment_amount_type
   */
  exports.prototype['payment_amount_type'] = undefined;
  /**
   * The unique identifier in the client system for the payment.
   * @member {String} payment_reference
   */
  exports.prototype['payment_reference'] = undefined;
  /**
   * The date on which the payment is expected to be settled with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
   * @member {String} expected_payment_settlement_date
   */
  exports.prototype['expected_payment_settlement_date'] = undefined;
  /**
   * The date on which the payment is captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
   * @member {String} payment_entry_date
   */
  exports.prototype['payment_entry_date'] = undefined;
  /**
   * The date on which the ACH returns is received by Orbipay.
   * @member {String} payment_return_date
   */
  exports.prototype['payment_return_date'] = undefined;
  /**
   * The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.
   * @member {String} return_code
   */
  exports.prototype['return_code'] = undefined;
  /**
   * @member {String} comments
   */
  exports.prototype['comments'] = undefined;
  /**
   * @member {module:models/SimplePaymentCustomerResponse} customer
   */
  exports.prototype['customer'] = undefined;
  /**
   * @member {module:models/FundingAccountResponse} funding_account
   */
  exports.prototype['funding_account'] = undefined;
  /**
   * @member {module:models/CustomerAccountResponse} customer_account
   */
  exports.prototype['customer_account'] = undefined;
  /**
   * @member {module:models/PaymentNetworkResponseVo} payment_network_response
   */
  exports.prototype['payment_network_response'] = undefined;
  /**
   * @member {module:models/AuditInfoVo} audit_info
   */
  exports.prototype['audit_info'] = undefined;


  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "scheduled"
     * @const
     */
    "scheduled": "scheduled",
    /**
     * value: "cancelled"
     * @const
     */
    "cancelled": "cancelled",
    /**
     * value: "processing"
     * @const
     */
    "processing": "processing",
    /**
     * value: "processed"
     * @const
     */
    "processed": "processed",
    /**
     * value: "returned"
     * @const
     */
    "returned": "returned",
    /**
     * value: "declined"
     * @const
     */
    "declined": "declined",
    /**
     * value: "disputed"
     * @const
     */
    "disputed": "disputed",
    /**
     * value: "refunded"
     * @const
     */
    "refunded": "refunded"  };

  /**
   * Allowed values for the <code>payment_method</code> property.
   * @enum {String}
   * @readonly
   */
  exports.PaymentMethodEnum = {
    /**
     * value: "ach"
     * @const
     */
    "ach": "ach",
    /**
     * value: "check"
     * @const
     */
    "check": "check",
    /**
     * value: "visa_debit"
     * @const
     */
    "visa_debit": "visa_debit",
    /**
     * value: "pinless_debit"
     * @const
     */
    "pinless_debit": "pinless_debit",
    /**
     * value: "master_debit"
     * @const
     */
    "master_debit": "master_debit",
    /**
     * value: "amex_credit"
     * @const
     */
    "amex_credit": "amex_credit",
    /**
     * value: "discover_credit"
     * @const
     */
    "discover_credit": "discover_credit",
    /**
     * value: "visa_credit"
     * @const
     */
    "visa_credit": "visa_credit",
    /**
     * value: "master_credit"
     * @const
     */
    "master_credit": "master_credit",
    /**
     * value: "cash"
     * @const
     */
    "cash": "cash",
    /**
     * value: "discover_debit"
     * @const
     */
    "discover_debit": "discover_debit"  };

  /**
   * Allowed values for the <code>payment_schedule_type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.PaymentScheduleTypeEnum = {
    /**
     * value: "one_time_payment"
     * @const
     */
    "one_time_payment": "one_time_payment",
    /**
     * value: "autopay_generated_payment"
     * @const
     */
    "autopay_generated_payment": "autopay_generated_payment",
    /**
     * value: "variable_recurring_generated_payment"
     * @const
     */
    "variable_recurring_generated_payment": "variable_recurring_generated_payment",
    /**
     * value: "payment_plan_generated"
     * @const
     */
    "payment_plan_generated": "payment_plan_generated"  };

  /**
   * Allowed values for the <code>payment_amount_type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.PaymentAmountTypeEnum = {
    /**
     * value: "current_balance"
     * @const
     */
    "current_balance": "current_balance",
    /**
     * value: "minimum_payment_due"
     * @const
     */
    "minimum_payment_due": "minimum_payment_due",
    /**
     * value: "past_payment_due"
     * @const
     */
    "past_payment_due": "past_payment_due",
    /**
     * value: "statement_balance"
     * @const
     */
    "statement_balance": "statement_balance",
    /**
     * value: "discounted_amount"
     * @const
     */
    "discounted_amount": "discounted_amount",
    /**
     * value: "penalty_amount"
     * @const
     */
    "penalty_amount": "penalty_amount",
    /**
     * value: "other"
     * @const
     */
    "other": "other"  };


  return exports;
}));


