/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.5.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OrbipayPaymentsapiClient) {
      root.OrbipayPaymentsapiClient = {};
    }
    root.OrbipayPaymentsapiClient.SourcePaymentCustomer = factory(root.OrbipayPaymentsapiClient.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SourcePaymentCustomer model module.
   * @module models/SourcePaymentCustomer
   * @version 1.5.0
   */

  /**
   * Constructs a new <code>SourcePaymentCustomer</code>.
   * @alias module:models/SourcePaymentCustomer
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>SourcePaymentCustomer</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:models/SourcePaymentCustomer} obj Optional instance to populate.
   * @return {module:models/SourcePaymentCustomer} The populated <code>SourcePaymentCustomer</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('customer_reference')) {
        obj['customer_reference'] = ApiClient.convertToType(data['customer_reference'], 'String');
      }
    }
    return obj;
  };

  /**
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * This URL fetches the details of source payment.
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * The unique identifier in the client system for the customer.
   * @member {String} customer_reference
   */
  exports.prototype['customer_reference'] = undefined;



  return exports;
}));


